//-----------------------------------------
// LScript Modeler InverseBridge
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=1.0;

@version 2.2
@warnings
@script modeler

// global values go here

main
{
    if(hostVersion()>=9)
        undogroupbegin();
    selmode(USER);
    selpolygon(CLEAR,NVLT,3);
    selpolygon(CLEAR,CURVE);
    selpolygon(CLEAR,BONE);
    selpolygon(CLEAR,MBALL);
    selmode(DIRECT);
//debug();
    mycount=polycount();
    if(mycount[4]<1 && mycount[5]<1 && mycount[6]<1)
    {
        error("Please select some polygons");
        return;
    }
    selmode(USER);
    editbegin();
        mypolys = polygons;
        edges=FindEndPoints(mypolys);
    editend();
        if(edges==nil)
        {
            return;
        }
        if(edges!=0)
        {
//debug();
            editbegin();
            newpoly=addpolygon(edges);
            editend();
            mypolys+=newpoly;
            floorpolys=InverseBridge(mypolys);
            editbegin();
            newpoly=addpolygon(edges);
            editend();
        }
        else
            floorpolys=InverseBridge(mypolys);
    delete();

    selpolygon(SET,POLYID,floorpolys);
    selpolygon(SET,CONNECT);
    alignpols();
    selpolygon(CLEAR);
    selpolygon(SET,POLYID,floorpolys);


    if(hostVersion()>=9)
        undogroupend();

//     info("Floor Created");

}

InverseBridge:polylist
{
    selpolygon(CLEAR);
    selpolygon(SET,POLYID,polylist);
    triple();
    alignpols();
    selmode(USER);
    editbegin();
        mypolys = polygons;
        loop=1;
        toppoly[1]=1;
        btmpoly[1]=1;
        pointindex=1;
//debug();
        for(i=1;i<mypolys.size();i++)
        {
            mypoly=mypolys[i];
            mypoints = polyinfo(mypoly);
            mypoints[1]=mypoints[4];
            polyfound=0;
            for(j=1;j<mypoints.size();j++)
            {
                edge[1] = mypoints[j];
                edge[2] = mypoints[j+1];
                for(p=i+1;p<=mypolys.size();p++)
                {
                    mynewpoly=mypolys[p];
                    mynewpoints=polyinfo(mynewpoly);
                    if(mynewpoints.contains(edge[1]) && mynewpoints.contains(edge[2]))
                    {
//debug();
                        // adjoining polyfound!
                        temp=mypolys[p];
                        mypolys[p]=mypolys[i+1];
                        mypolys[i+1]=temp;

                        toppoly[pointindex]=edge[1];
                        btmpoly[pointindex]=edge[2];
                        pointindex++;

                        polyfound=1;
                        break;
                    }
                }
                if(polyfound)
                {
                    break;
                }
            }
            if(j>=mypoints.size())
            {
                loop=0;
            }
        }
        toppoly.reduce();
        toppoly.trunc();
        btmpoly.reduce();
        btmpoly.trunc();

        newpoly[1]=addpolygon(toppoly,"Floor");
        newpoly[2]=addpolygon(btmpoly,"Floor");
    editend();
        return(newpoly);
}

FindEndPoints:polylist
{
//debug();
    myarray[1][1]=0; // polyid
    myarray[1][2][1]=@0,0@; //connencted poly edges as vertices
    myarray[1][3][1]=0; //connected polygons
    for (i=1;i<=polylist.size();i++)
    {
        mypoly=polylist[i];
        myarray[i][1]=mypoly;
        mypoints=polyinfo(mypoly);
        mypoints[1]=mypoints[mypoints.size()]; // loop points.
        edgeindex=1;
        for(j=1;j<mypoints.size();j++)
        {
            foreach(p,polylist)
            {
                if(p!=mypoly)
                {
                    testpoints=polyinfo(p);
                    if(testpoints.contains(mypoints[j]) && testpoints.contains(mypoints[j+1]))
                    {
                        myarray[i][2][edgeindex]=@mypoints[j],mypoints[j+1]@;
                        myarray[i][3][edgeindex]=p;
                        edgeindex++;
                    }
                }
            }
        }
    }
    index=1;
    if(myarray[1][1]==0)
        return(0);
    for(i=1;i<=myarray.size();i++)
    {
        if(myarray[i][2].size()==1)
        {
            endpolys[index]=myarray[i];
            index++;
        }
    }
//debug();
    if(endpolys.size()==0)
        return(0);
    if(endpolys.size()>2)
    {
        error("Please select one group of polygons");
        return(nil);
    }


    ecount=1;
    for(i=1;i<=endpolys.size();i++)
    {
        mypoints=polyinfo(endpolys[i][1]);
        if(mypoints.size()!=5)
        {
            error("Ends of poly chain must be quads");
            return(nil);
        }
        mypoints[1]=mypoints[mypoints.size()];
        for(j=1;j<mypoints.size();j++)
        {
            edge=@mypoints[j],mypoints[j+1]@;
            polyedges=endpolys[i][2][1];
            if(!polyedges.contains(edge[1]) && !polyedges.contains(edge[2]))
            {
                edges[ecount]=edge[1];
                edges[ecount+1]=edge[2];
                ecount=ecount+2;
            }
        }
    }
    
    edges.pack();
    edges.trunc();

//    debug();
    return(edges);

}

